aboutsummaryrefslogtreecommitdiffstats
path: root/test/scripts/run_in_venv_with_cleanup.sh
diff options
context:
space:
mode:
Diffstat (limited to 'test/scripts/run_in_venv_with_cleanup.sh')
-rwxr-xr-xtest/scripts/run_in_venv_with_cleanup.sh39
1 files changed, 39 insertions, 0 deletions
diff --git a/test/scripts/run_in_venv_with_cleanup.sh b/test/scripts/run_in_venv_with_cleanup.sh
new file mode 100755
index 00000000..35b6737e
--- /dev/null
+++ b/test/scripts/run_in_venv_with_cleanup.sh
@@ -0,0 +1,39 @@
+#!/bin/bash
+
+rv=0
+
+atexit() {
+ group_id=`ps -p $$ -o pgid=`
+ my_id=$$
+ ids=`pgrep -g $group_id -d ' ' | sed "s/\b$my_id\b//g"`
+ echo "Killing possible remaining process IDs: $ids"
+ for id in $ids
+ do
+ if ps -p $id > /dev/null
+ then
+ kill -9 $id
+ fi
+ done
+ exit ${rv}
+}
+
+trap "atexit;" SIGINT SIGTERM
+
+FORCE_FOREGROUND=$1
+shift
+
+source $1
+shift
+
+if [[ "${FORCE_FOREGROUND}" == "1" ]]
+then
+ $*
+else
+ $* &
+ pid=$!
+ wait ${pid}
+fi
+
+rv=$?
+atexit
+exit ${rv}